/*******************************************************************************/
/* Function: Anzeige.DLL Loader 
/*			 Goldammer GmbH (C) 2005
/*
/* Date		  Dev						Comment
/* ----------------------------------------------------------------------------*/
/* 09.06.2005 Torsten Schinkel			Init Release
/*
/*
/*******************************************************************************/
#include <windows.h>
#include <stdio.h>

#define ANZEIGE_DLL_PATH0	"../common/anzeige.dll"
#define ANZEIGE_DLL_PATH1	"anzeige.dll"

/*******************************************************************************/
/* Funktionsprototypen   												       */
/*******************************************************************************/
//-Main-------------------------------------------------------------------
void (__stdcall	*ShowGraph)							(int Nr);
void (__stdcall	*GraphAddPoint)						(int Nr, int Channel, double Value);
void (__stdcall	*GraphConfigChannel)				(int Nr, int Channel, int Color);
void (__stdcall	*GraphSetMinMax)					(int Nr, double MinX, double MaxX, double MinY, double MaxY);
void (__stdcall	*HideGraph)							(int Nr);
void (__stdcall	*DestroyGraph)						(int Nr);
void (__stdcall	*PositionGraph)						(int Nr, int x, int y, int Width, int Height);
void (__stdcall	*ShowDisplay)						(int Nr);
void (__stdcall	*AddDisplay)						(int Nr, int XRatio, int YRatio, int WidthRatio, int HeightRatio, int Color);
void (__stdcall	*ProcessMessages)					(void);


// helps eliminate warnings
template<typename T, typename U> void assign(T& dest, U src) { dest = (T&)src; }


HINSTANCE Init_AnzeigeDLL(void)
{
	HINSTANCE hInst_DLL = NULL;
	
	if (!hInst_DLL) hInst_DLL = LoadLibrary(ANZEIGE_DLL_PATH0);
	if (!hInst_DLL) hInst_DLL = LoadLibrary(ANZEIGE_DLL_PATH1);

	int LoadWarning = 0;

	if (!hInst_DLL) {
		puts("[mc4self.dll] Couldn't find anzeige.dll");
		return NULL;
	}

	//--Main------------------------------------------------------------------
	assign(ShowGraph, GetProcAddress(hInst_DLL, "ShowGraph"));
	assign(GraphAddPoint, GetProcAddress(hInst_DLL, "GraphAddPoint"));
	assign(GraphConfigChannel, GetProcAddress(hInst_DLL, "GraphConfigChannel"));
	assign(GraphSetMinMax, GetProcAddress(hInst_DLL, "GraphSetMinMax"));
	assign(HideGraph, GetProcAddress(hInst_DLL, "HideGraph"));
	assign(DestroyGraph, GetProcAddress(hInst_DLL, "DestroyGraph"));
	assign(PositionGraph, GetProcAddress(hInst_DLL, "PositionGraph"));
	assign(ShowDisplay, GetProcAddress(hInst_DLL, "ShowDisplay"));
	assign(AddDisplay, GetProcAddress(hInst_DLL, "AddDisplay"));
	assign(ProcessMessages, GetProcAddress(hInst_DLL, "ProcessMessages"));

	if ( !ShowGraph ||
		 !GraphAddPoint ||
		 !GraphConfigChannel ||
		 !GraphSetMinMax ||
		 !HideGraph ||
		 !DestroyGraph ||
		 !PositionGraph ||
		 !ShowDisplay ||
		 !AddDisplay ||
		 !ProcessMessages) {
		puts("[anzeige.dll] Couldn't get all entry points");
		FreeLibrary(hInst_DLL);
		return NULL;
	}

	return hInst_DLL;
}

BOOL DeInit_AnzeigeDLL(HINSTANCE hInst)
{
	if (hInst != NULL) {
		FreeLibrary(hInst);
		hInst = NULL;
		return TRUE;
	}

	return FALSE;
}
