unit SelfHeader;

interface
uses Windows, SysUtils;
const DLLName='MC4SELF.DLL';
      MEMSIZE=4096;

const SUCCESS = 0;
      FAILURE = 1;
      INVALID_ARGUMENT = 2;
      OVERFLOW = 3;

      FINISHED = 10;
      INACTIVE = 11;
      RUNNING = 12;

const ICPChannels=16;

type TICPStruct=Record
  ICP:  Integer;
  AC:   Integer;
  Gain: Integer;
  SE:   Integer;
end;
type PICPStruct=^TICPSTRUCT;

type Flashdaten=Record
  Name: array[0..31] of char;
  Serial: array[0..19] of char;
  AnzahlAD: integer;
  BitbreiteAD: integer;
  AnzahlDA: integeR;
  BitbreiteDA: integer;
  AnzahlCT: integer;
  AnzahlTTL: integer;
  PortbreiteTTL: integer;
  AnzahlPWM: integer;
end;

type Eingangsspannungsbereich=Record
  LowBorder: double;
  HighBorder: double;
end;
type FlashdatenEx=Record
  Name: array[0..31] of char;
  Serial: array[0..19] of char;
  AnzahlAD: integer;
  BitbreiteAD: integer;
  AnzahlDA: integer;
  BitbreiteDA: integer;
  AnzahlCT: integer;
  AnzahlTTL: integer;
  PortbreiteTTL: integer;
  AnzahlPWM: integer;
  SE_Possible: integer;
  SE_Summe: integer;
  Dif_Possible: integer;
  Dif_Summe: integer;
  NumOfESB: integer;
  Eingangsbereiche: array[0..9] of Eingangsspannungsbereich;
  NumOfGain: integer;
  Gain: array[0..3] of integer;
  TaktBasis: integer;
end;


type EnhancedInformations=Record
  {$IfDef USB}
  BusType: integer;
  FirmwareVersion: DWORD;
  ReservedForFutureUse: array[0..5] of DWORD;
  {$Else}
  WDMVersion: integer;
  ReservedForFutureUse: array[0..6] of DWORD;
  {$EndIf}
end;

(* {$Define LoadStatic} *)
{xx$xxDefine LoadStatic}
{$Undef LoadStatic}

{$IfDef LoadStatic}
// Kartenfunktionen
function LoadCard(CardNr: integer): integer;stdcall;external DLLName;
function OpenCard(CardNr: integer): integer;stdcall;external DLLName;
function SwitchCard(CardNr: integer): integer;stdcall;external DLLName;
function CloseCard(CardNr: integer): integer;stdcall;external DLLName;
function ReadFlashData(CardNr: integer; BufferPtr: Pointer): integer;stdcall;external DLLName;
function ReadFlashDataEx(CardNr: integer; BufferPtr: Pointer): integer;stdcall;external DLLName;
function GetEnhancedInformations(CardID: integer; Destination: Pointer): integer;stdcall;external DLLName;
function ConfigCard(Differenzmodus: integer; ADWandler: integer; DARange: integer): integer;stdcall;external DLLName;
// Generische Funktionen
function ClearChannelLists: integer;stdcall;external DLLName;
function ClearChannelListsEx(CardNr: integer; SWTakt: integer; SWSignalisierung: integer): integer;stdcall;external DLLName;
function FinalInit: integer;stdcall;external DLLName;
// Analoge Erfassung
function CaptureOneChannel(ChannelNumber: integer; Differenzmodus: integer; InputRange: integer; ScaledValue: Pointer; BinaryValue: Pointer): integer;stdcall;external DLLName;
function CaptureOneChannelEx(ChannelNumber: integer;Differenzmodus: integer;InputRange: integer;Gain: integer;Oversampling: integer; Bipolar: integer;
                             ScaledValue: Pointer;BinaryValue: Pointer): integer;stdcall;external DLLName;
function PrepareFilterEntry( Channel: integer;
                             Filtermode: integer;
                             SampleFreq: integer;
                             Freq1: double;
                             Freq2: double;
                             Freq3: double;
                             Freq4: double;
                             Passabsorption: double;
                             Stopbandattenuation: double;
                             MaxOrder: integer;
                             DesignMethod: integer;
                             FilterTyp: integer;
                             Window: integer;
                             Param1: integer): integer;stdcall;external DLLName;
function PrepareTriggerEntry( Channel: integer;
                              // Starttrigger
                              StartTriggerAktiv: integer;
                              StartTriggerSchwelle1: double;
                              StartTriggerSchwelle2: double;
                              StartTriggerTyp: integer;
                              StartTriggerAbStart: integer;
                              StartTriggerMessung: integer;
                              StartTriggerSetTTL: integer;
                              StartTriggerTTLKlemme: integer;
                              StartTriggerTTLStartzustand: integer;
                              StartTriggerTTLFlanke: integer;
                              // Stoptrigger
                              StopTriggerAktiv: integer;
                              StopTriggerSchwelle1: double;
                              StopTriggerSchwelle2: double;
                              StopTriggerTyp: integer;
                              StopTriggerAbStart: integer;
                              StopTriggerMessung: integer;
                              StopTriggerSetTTL: integer;
                              StopTriggerTTLKlemme: integer;
                              StopTriggerTTLStartzustand: integer;
                              StopTriggerTTLFlanke: integer;
                              // Generell
                              Retriggerbar: integer
                            ): integer;stdcall;external DLLName;
function SetGlobalTriggerValues( Pretrigger: integer;
                                 Posttrigger: integer;
                                 WaitForStartTrigger: integer
                               ): integer;stdcall;external DLLName;
function PrepareTriggerTakt(Channel: integer; AnzahlWerteProTakt: integer; Schwellwert: double; Schwellenart: integer): integer;stdcall;external DLLName;
function PrepareFFTEntry(Channel: integer; AnzahlPunkte: integer; Spektrum: integer; Gain: double; Fensterfunktion: integer; Parameter: double): integer;stdcall;external DLLName;
function PreparePIDEntry(Channel: integer;
                         PAnteil: double;
                         IAnteil: double;
                         DAnteil: double;
                         Reglerart: integer;
                         Gain: double;
                         Sollwert: double;
                         MinValue: double;
                         MaxValue: double;
                         DAKanal: integer;
                         SampleFreq: integer
                        ): integer;stdcall;external DLLName;
function GetFFTData(KanalNrInListe: integer; DestinationBuffer: Pointer): integer;stdcall;external DLLName;
function Add_AD_Channel_to_ScanList(ChannelNumber: integer; Oversampling: integer; Gain: integer; Bipolar: integer): integer;stdcall;external DLLName;
function Add_Dig_Channel_to_ScanList(ChannelNumber: integer; Typ: integer): integer;stdcall;external DLLName;
function Add_CT_Channel_to_ScanList(ChannelNumber: integer): integer;stdcall;external DLLName;
function SetADFrequency(FrequencyPerChannel: integer): integer;stdcall;external DLLName;
function SetADFrequencyEx(FrequencyPerChannel: integer; ReelleFrequenz: Pointer; Basisfrequenz: Pointer): integer;stdcall;external DLLName;
function StartADCapture: integer;stdcall;external DLLName;
function StartADCaptureEx(ExtDigTrigger: integer; ExtDigTakt: integeR; ExtDigFlanke: integer): integer;stdcall;external DLLName;
function StopADCapture: integer;stdcall;external DLLName;
function GetScaledData(InputRange: integer; DestinationBuffer: Pointer; NumberPerChannel: Pointer; SkipLessData: integer): integer;stdcall;external DLLName;
function GetBinaryData(DestinationBuffer: Pointer; NumberPerChannel: Pointer; SkipLessData: integer): integer;stdcall;external DLLName;
function GetADBufferStatus(CardID: integer; SampledValuesPerChannel: Pointer): integer;stdcall;external DllName;
// Analoge Ausgabe
function PutOneChannel(ChannelNumber: integer; OutputRange: integer; ScaledValue: double): integer;stdcall;external DLLName;
function Add_DA_Channel_to_ScanList(ChannelNumber: integer): integer;stdcall;external DLLName;
function Add_DA_Channel_to_ScanListEx(ChannelNumber: integer; Buffertype: integer; BufferSize: integer): integer;stdcall;external DLLName;
function SetDAFrequency(FrequencyPerChannel: integer): integer;stdcall;external DLLName;
function StartDAOutput: integer;stdcall;external DLLName;
function StopDAOutput: integer;stdcall;external DLLName;
function PutScaledData(OutputRange: integer; SourceBuffer: Pointer; NumberOfChannels: integer; NumberPerChannel: Pointer; SkipLessData: integer): integer;stdcall;external DLLName;
function PutBinaryData(SourceBuffer: Pointer; NumberOfChannels: integer; NumberPerChannel: Pointer; SkipLessData: integer): integer;stdcall;external DLLName;
function GetDAFreeBufferSpace(CardID: integer; FreeWordsPerChannel: Pointer): integer;stdcall;external DLLName;
// Digital I/O
function SetDigitalDirection(Channel: integer; Direction: integer): integer;stdcall;external DLLName;
function ReadDigitalBit(Channel: integer; Value: Pointer): integer;stdcall;external DLLName;
function WriteDigitalBit(Channel: integer; Value: integer): integer;stdcall;external DLLName;
function SetDigitalPortDirection(StartChannel: integer; Bits: integer; Direction: integer): integer;stdcall;external DLLName;
function ReadDigitalPort(StartChannel: integer; Bits: integer; Value: Pointer): integer;stdcall;external DLLName;
function WriteDigitalPort(StartChannel: integer; Bits: integer; Value: integer): integer;stdcall;external DLLName;
// Zhlerfunktionen
function ConfigureCounterInput(ChannelNumber: integer; Countermode: integer; PresetValue: integer;
                               FrequencyResolution: integer; Flanke: integer;
                               InkrementalSWReset: integer; InkrementalHWReset: integer;
                               InkrementalHWResetFlanke: integer; InkrementalInterpolation: integer
                               ): integer;stdcall;external DLLName;
function ConfigureCounterInputEx(ChannelNumber: integer; Countermode: integer; PresetValue: integer;
                               FrequencyResolution: integer; Flanke: integer;
                               InkrementalSWReset: integer; InkrementalHWReset: integer;
                               InkrementalHWResetFlanke: integer; InkrementalInterpolation: integer;
                               InkrementalResolution: integer): integer;stdcall;external DLLName;
function ReadCounterValue(ChannelNumber: integer; Value: Pointer): integer;stdcall;external DLLName;
function CT_AddChannel_To_CTScanlist(Channel: integer): integer;stdcall;external DLLName;
function SetCTFrequency(Frequency: double): integer;stdcall;external DLLName;
function StartCTCapture: integer;stdcall;external DLLName;
function StartCTCaptureEx(ExtDigTrigger: integer; ExtDigTakt: integer; ExtDigFlanke: integer): integer;stdcall;external DLLName;
function StopCTCapture: integer;stdcall;external DLLName;
function CT_GetScaledData(DestinationBuffer: Pointer; NumberPerChannel: Pointer; SkipLessData: integer): integer;stdcall;external DLLName;
function CT_GetBinaryData(DestinationBuffer: Pointer; NumberPerChannel: Pointer; SkipLessData: integer): integer;stdcall;external DLLName;
// Pulsweitenausgabe
function PreparePWMOutput(ChannelNumber: integer; BaseFrequency: integer; StartRatio: integer): integer;stdcall;external DLLName;
function PrepareFMOutput(ChannelNumber: integer; StartFrequency: integer; PulsWidthRatio: integer): integer;stdcall;external DLLName;
function WriteNewPWMRatio(ChannelNumber: integer; BaseFrequency: integer; Ratio: integer): integer;stdcall;external DLLName;
function WriteNewFMRatio(ChannelNumber: integer; Frequency: integer; PWRatio: integer): integer;stdcall;external DLLName;

// MM-IRQ
function PrepareExtTrigger(CardID: integer;ExtDigTrigger: integer; ExtDigTakt: integeR; ExtDigFlanke: integer):integer;stdcall;external DLLName;
function StartMemoryMeasurement(CardID: integer;
                                AnzahlKanaele: integer;
                                ValuesPerChannel: integer;
                                FrequencyPerChannel: integer
                               ): integer;stdcall;external DLLName;
function StartMemoryMeasurementEx(CardID: integer;
                                AnzahlKanaele: integer;                         // Wieviele Kanle werden gemessen
                                ValuesPerChannel: integer;                      // Werte pro Kanal, die erfasst werden sollen
                                FrequencyPerChannel: integer;                    // Abtastrate pro Kanal, um MM-IRQ Delay zu berechnen
                                UsualBlockSize: integeR
                               ): integer;stdcall;External DLLName;                               
function StopMemoryMeasurement(CardID: integer): integer;stdcall;external DLLName;
function GetScaledDataFromMemoryMeasurement(CardID: integer;
                                            InputRange: integer;
                                            AnzahlKanaele: integer;
                                            ValuesPerChannel: integer;
                                            Destination: Pointer;
                                            SkipIfLessData: integer;
                                            TransferedWords: Pointer
                                           ): integer;stdcall;external DLLName
function GetBinaryDataFromMemoryMeasurement(CardID: integer;
                                            AnzahlKanaele: integer;
                                            ValuesPerChannel: integer;
                                            Destination: Pointer;
                                            SkipIfLessData: integer;
                                            TransferedWords: Pointer
                                           ): integer;stdcall;external DLLName
function GetMemoryMeasurementStatus(CardID: integer): integer;stdcall;external DLLName
function DeInitMemoryMeasurement(CardID: integer): integer;stdcall;external DLLName;
function ShowDebugNumber(i: integer): integer;stdcall;external DLLName;
function GetDLLVersion(VString: Pointer; V1: Pointer; V2: Pointer; V3: Pointer): integer;stdcall;external DLLName;

function EnableUKExtension(CardID: integer): integer; stdcall;external DLLName;
function GetProjectVars(CardID: integer; Destination: Pointer): integer;stdcall;external DLLName;
function SetProjectVars(CardID: integer; NumOfPulses: integer; NumOfShiftK0: integer; NumOfShiftK2to3: integer): integer; stdcall;external DLLName;

function ProgramUserTimerFrequency(CardID: integer; Delay_in_ms: integer): integer;stdcall;external DLLName;
function StartUserTimer(CardID: integer; EventHandle: THandle): integer;stdcall;external DLLName;
function StopUserTimer(CardID: integer): integer;stdcall;external DLLName;

function SendICPSettings(CardID: integer; ICPStruct: Pointer): integer;stdcall;external DLLName;

{$Else}
(******************************************************************************)
(* Prototypen fr das dynamische Laden der DLL                                *)
(******************************************************************************)
// Kartenfunktionen
type TLoadCard=function(CardID: integer): integer;stdcall;
type TOpenCard=function(CardNr: integer): integer;stdcall;
type TSwitchCard=function(CardNr: integer): integer;stdcall;
type TCloseCard=function(CardNr: integer): integer;stdcall;
type TReadFlashData=function(CardNr: integer; BufferPtr: Pointer): integer;stdcall;
type TReadFlashDataEx=function(CardNr: integer; BufferPtr: Pointer): integer;stdcall;
type TGetEnhancedInformations=function(CardID: integer; Destination: Pointer): integer;stdcall;
type TConfigCard=function(Differenzmodus: integer; ADWandler: integer; DARange: integer): integer;stdcall;
// Generische Funktionen
type TClearChannelLists=function:integer;stdcall;
type TClearChannelListsEx=function(CardNr: integer; SWTakt: integer; SWSignalisierung: integer): integer;stdcall;
type TFinalInit=function: integer;stdcall;
// Analoge Erfassung
type TCaptureOneChannel=function(ChannelNumber: integer; Differenzmodus: integer; InputRange: integer; ScaledValue: Pointer; BinaryValue: Pointer): integer;stdcall;
type TCaptureOneChannelEx=function(ChannelNumber: integer;Differenzmodus: integer;InputRange: integer;Gain: integer;Oversampling: integer; Bipolar: integer;
                             ScaledValue: Pointer;BinaryValue: Pointer): integer;stdcall;
type TPrepareFilterEntry=function( Channel: integer;
                             Filtermode: integer;
                             SampleFreq: integer;
                             Freq1: double;
                             Freq2: double;
                             Freq3: double;
                             Freq4: double;
                             Passabsorption: double;
                             Stopbandattenuation: double;
                             MaxOrder: integer;
                             DesignMethod: integer;
                             FilterTyp: integer;
                             Window: integer;
                             Param1: integer): integer;stdcall;
type TPrepareTriggerEntry=function( Channel: integer;
                              // Starttrigger
                              StartTriggerAktiv: integer;
                              StartTriggerSchwelle1: double;
                              StartTriggerSchwelle2: double;
                              StartTriggerTyp: integer;
                              StartTriggerAbStart: integer;
                              StartTriggerMessung: integer;
                              StartTriggerSetTTL: integer;
                              StartTriggerTTLKlemme: integer;
                              StartTriggerTTLStartzustand: integer;
                              StartTriggerTTLFlanke: integer;
                              // Stoptrigger
                              StopTriggerAktiv: integer;
                              StopTriggerSchwelle1: double;
                              StopTriggerSchwelle2: double;
                              StopTriggerTyp: integer;
                              StopTriggerAbStart: integer;
                              StopTriggerMessung: integer;
                              StopTriggerSetTTL: integer;
                              StopTriggerTTLKlemme: integer;
                              StopTriggerTTLStartzustand: integer;
                              StopTriggerTTLFlanke: integer;
                              // Generell
                              Retriggerbar: integer
                            ): integer;stdcall;
type TSetGlobalTriggerValues=function( Pretrigger: integer;
                                 Posttrigger: integer;
                                 WaitForStartTrigger: integer
                               ): integer;stdcall;
type TPrepareTriggerTakt=function(Channel: integer; AnzahlWerteProTakt: integer; Schwellwert: double; Schwellenart: integer): integer;stdcall;
type TPrepareFFTEntry=function(Channel: integer; AnzahlPunkte: integer; Spektrum: integer; Gain: double; Fensterfunktion: integer; Parameter: double): integer;stdcall;
type TPreparePIDEntry=function(Channel: integer;
                         PAnteil: double;
                         IAnteil: double;
                         DAnteil: double;
                         Reglerart: integer;
                         Gain: double;
                         Sollwert: double;
                         MinValue: double;
                         MaxValue: double;
                         DAKanal: integer;
                         SampleFreq: integer
                        ): integer;stdcall;
type TGetFFTData=function(KanalNrInListe: integer; DestinationBuffer: Pointer): integer;stdcall;
type TAdd_AD_Channel_to_ScanList=function(ChannelNumber: integer; Oversampling: integer; Gain: integer; Bipolar: integer): integer;stdcall;
type TAdd_Dig_Channel_to_ScanList=function(ChannelNumber: integer; Typ: integer): integer;stdcall;
type TAdd_CT_Channel_to_ScanList=function(ChannelNumber: integer): integer;stdcall;
type TSetADFrequency=function(FrequencyPerChannel: integer): integer;stdcall;
type TSetADFrequencyEx=function(FrequencyPerChannel: integer; ReelleFrequenz: Pointer; Basisfrequenz: Pointer): integer;stdcall;
type TStartADCapture=function: integer;stdcall;
type TStartADCaptureEx=function(ExtDigTrigger: integer; ExtDigTakt: integeR; ExtDigFlanke: integer): integer;stdcall;
type TStopADCapture=function: integer;stdcall;
type TGetScaledData=function(InputRange: integer; DestinationBuffer: Pointer; NumberPerChannel: Pointer; SkipLessData: integer): integer;stdcall;
type TGetBinaryData=function(DestinationBuffer: Pointer; NumberPerChannel: Pointer; SkipLessData: integer): integer;stdcall;
// Analoge Ausgabe
type TPutOneChannel=function(ChannelNumber: integer; OutputRange: integer; ScaledValue: double): integer;stdcall;
type TAdd_DA_Channel_to_ScanList=function(ChannelNumber: integer): integer;stdcall;
type TAdd_DA_Channel_to_ScanListEx=function(ChannelNumber: integer; Buffertype: integer; BufferSize: integer): integer;stdcall;
type TSetDAFrequency=function(FrequencyPerChannel: integer): integer;stdcall;
type TStartDAOutput=function: integer;stdcall;
type TStopDAOutput=function: integer;stdcall;
type TPutScaledData=function(OutputRange: integer; SourceBuffer: Pointer; NumberOfChannels: integer; NumberPerChannel: Pointer; SkipLessData: integer): integer;stdcall;
type TPutBinaryData=function(SourceBuffer: Pointer; NumberOfChannels: integer; NumberPerChannel: Pointer; SkipLessData: integer): integer;stdcall;
type TGetDAFreeBufferSpace=function(CardID: integer; FreeWordsPerChannel: Pointer): integer;stdcall;
// Digital I/O
type TSetDigitalDirection=function(Channel: integer; Direction: integer): integer;stdcall;
type TReadDigitalBit=function(Channel: integer; Value: Pointer): integer;stdcall;
type TWriteDigitalBit=function(Channel: integer; Value: integer): integer;stdcall;
type TSetDigitalPortDirection=function(StartChannel: integer; Bits: integer; Direction: integer): integer;stdcall;
type TReadDigitalPort=function(StartChannel: integer; Bits: integer; Value: Pointer): integer;stdcall;
type TWriteDigitalPort=function(StartChannel: integer; Bits: integer; Value: integer): integer;stdcall;
// Zhlerfunktionen
type TConfigureCounterInput=function(ChannelNumber: integer; Countermode: integer; PresetValue: integer;
                               FrequencyResolution: integer; Flanke: integer;
                               InkrementalSWReset: integer; InkrementalHWReset: integer;
                               InkrementalHWResetFlanke: integer; InkrementalInterpolation: integer
                               ): integer;stdcall;
type TConfigureCounterInputEx=function(ChannelNumber: integer; Countermode: integer; PresetValue: integer;
                               FrequencyResolution: integer; Flanke: integer;
                               InkrementalSWReset: integer; InkrementalHWReset: integer;
                               InkrementalHWResetFlanke: integer; InkrementalInterpolation: integer;
                               InkrementalResolution: integer): integer;stdcall;
type TReadCounterValue=function(ChannelNumber: integer; Value: Pointer): integer;stdcall;
type TCT_AddChannel_To_CTScanlist=function(Channel: integer): integer;stdcall;
type TSetCTFrequency=function(Frequency: double): integer;stdcall;
type TStartCTCapture=function: integer;stdcall;
type TStartCTCaptureEx=function(ExtDigTrigger: integer; ExtDigTakt: integer; ExtDigFlanke: integer): integer;stdcall;
type TStopCTCapture=function: integer;stdcall;
type TCT_GetScaledData=function(DestinationBuffer: Pointer; NumberPerChannel: Pointer; SkipLessData: integer): integer;stdcall;
type TCT_GetBinaryData=function(DestinationBuffer: Pointer; NumberPerChannel: Pointer; SkipLessData: integer): integer;stdcall;
// Pulsweitenausgabe
type TPreparePWMOutput=function(ChannelNumber: integer; BaseFrequency: integer; StartRatio: integer): integer;stdcall;
type TPrepareFMOutput=function(ChannelNumber: integer; StartFrequency: integer; PulsWidthRatio: integer): integer;stdcall;
type TWriteNewPWMRatio=function(ChannelNumber: integer; BaseFrequency: integer; Ratio: integer): integer;stdcall;
type TWriteNewFMRatio=function(ChannelNumber: integer; Frequency: integer; PWRatio: integer): integer;stdcall;

// MM-IRQ
type TPrepareExtTrigger=function(CardID: integer;ExtDigTrigger: integer; ExtDigTakt: integeR; ExtDigFlanke: integer):integer;stdcall;
type TStartMemoryMeasurement=function(CardID: integer;
                                AnzahlKanaele: integer;
                                ValuesPerChannel: integer;
                                FrequencyPerChannel: integer
                               ): integer;stdcall;
type TStartMemoryMeasurementEx=function(CardID: integer;
                                AnzahlKanaele: integer;                         // Wieviele Kanle werden gemessen
                                ValuesPerChannel: integer;                      // Werte pro Kanal, die erfasst werden sollen
                                FrequencyPerChannel: integer;                    // Abtastrate pro Kanal, um MM-IRQ Delay zu berechnen
                                UsualBlockSize: integeR
                               ): integer;stdcall;
type TStopMemoryMeasurement=function(CardID: integer): integer;stdcall;
type TGetScaledDataFromMemoryMeasurement=function(CardID: integer;
                                            InputRange: integer;
                                            AnzahlKanaele: integer;
                                            ValuesPerChannel: integer;
                                            Destination: Pointer;
                                            SkipIfLessData: integer;
                                            TransferedWords: Pointer
                                           ): integer;stdcall;
type TGetBinaryDataFromMemoryMeasurement=function(CardID: integer;
                                            AnzahlKanaele: integer;
                                            ValuesPerChannel: integer;
                                            Destination: Pointer;
                                            SkipIfLessData: integer;
                                            TransferedWords: Pointer
                                           ): integer;stdcall;
type TGetMemoryMeasurementStatus=function(CardID: integer): integer;stdcall;
type TDeInitMemoryMeasurement=function(CardID: integer): integer;stdcall;
type TShowDebugNumber=function(i: integer): integer;stdcall;
type TGetDLLVersion=function(VString: Pointer; V1: Pointer; V2: Pointer; V3: Pointer): integer;stdcall;

type TProgramUserTimerFrequency=function(CardID: integer; Delay_in_ms: integer): integer;stdcall;
type TStartUserTimer=function(CardID: integer; EventHandle: THandle): integer;stdcall;
type TStopUserTimer=function(CardID: integer): integer;stdcall;

type TSendICPSettings=function(CardID: integer; ICPStruct: Pointer): integer;stdcall;

type TOutputPipe_PutScaledData=function(nCardID:               DWORD;
                                        nPipeType:             DWORD;
                                        nChannelID:            DWORD;
                                        nOutputRange:          DWORD;
                                        pSourceBuffer:         Pointer;
                                        pnNumberOfValues:      Pointer;
                                        SkipLessData:          DWORD): integer;stdcall;
type TOutputPipe_PutBinaryData=function(nCardID:               DWORD;
                                        nPipeType:             DWORD;
                                        nChannelID:            DWORD;
                                        pSourceBuffer:         Pointer;
                                        pnNumberOfValues:      Pointer;
                                        SkipLessData:          DWORD): integer;stdcall;
type TOutputPipe_GetFreeBufferSpace=function(nCardID:              DWORD;
                                             nPipeType:            DWORD;
                                             nChannelID:           DWORD;
                                             pFreeWordsPerChannel: Pointer): integer;stdcall;

var
  LoadCard: TLoadCard;
  OpenCard: TOpenCard;
  SwitchCard: TSwitchCard;
  CloseCard: TCloseCard;
  ReadFlashData: TReadFlashData;
  ReadflashDataEx: TReadFlashDataEx;
  GetEnhancedInformations: TGetEnhancedInformations;
  ConfigCard: TConfigCard;

  ClearChannelLists: TClearChannelLists;
  ClearChannelListsEx: TClearChannelListsEx;
  FinalInit: TFinalInit;

  CaptureOneChannel: TCaptureOneChannel;
  CaptureOneChannelEx: TCaptureOneChannelEx;
  PrepareFilterEntry: TPrepareFilterEntry;
  PrepareTriggerEntry: TPrepareTriggerEntry;
  SetGlobalTriggerValues: TSetGlobalTriggerValues;
  PrepareTriggerTakt: TPrepareTriggerTakt;
  PrepareFFTEntry: TPrepareFFTEntry;
  PreparePIDEntry: TPreparePIDEntry;

  GetFFTData: TGetFFTData;
  Add_AD_Channel_To_ScanList: TAdd_AD_Channel_to_ScanList;
  Add_Dig_Channel_To_Scanlist: TAdd_Dig_Channel_to_ScanList;
  Add_CT_Channel_to_ScanList: TAdd_CT_Channel_to_ScanList;
  SetADFrequency: TSetADFrequency;
  SetADFrequencyEx: TSetADFrequencyEx;
  StartADCapture: TStartADCapture;
  StartADCaptureEx: TStartADCaptureEx;
  StopADCapture: TStopADCapture;
  GetScaledData: TGetScaledData;
  GetBinaryData: TGetBinaryData;

  PutOneChannel: TPutOneChannel;
  Add_DA_Channel_to_ScanList: TAdd_DA_Channel_to_ScanList;
  Add_DA_Channel_to_ScanListEx: TAdd_DA_Channel_to_ScanListEx;
  SetDAFrequency: TSetDAFrequency;
  StartDAOutput: TStartDAOutput;
  StopDAOutput: TStopDAOutput;
  PutScaledData: TPutScaledData;
  PutBinaryData: TPutBinaryData;
  GetDAFreeBufferSpace: TGetDAFreeBufferSpace;

  SetDigitalDirection: TSetDigitalDirection;
  ReadDigitalBit: TReadDigitalBit;
  WriteDigitalBit: TWriteDigitalBit;
  SetDigitalPortDirection: TSetDigitalPortDirection;
  ReadDigitalPort: TReadDigitalPort;
  WriteDigitalPort: TWriteDigitalPort;

  ConfigureCounterInput: TConfigureCounterInput;
  ConfigureCounterInputEx: TConfigureCounterInputEx;
  ReadCounterValue: TReadCounterValue;
  CT_AddChannel_To_CTScanlist: TCT_AddChannel_To_CTScanlist;
  SetCTFrequency: TSetCTFrequency;
  StartCTCapture: TStartCTCapture;
  StartCTCaptureEx: TStartCTCaptureEx;
  StopCTCapture: TStopCTCapture;
  CT_GetScaledData: TCT_GetScaledData;
  CT_GetBinaryData: TCT_GetBinaryData;


  PreparePWMOutput: TPreparePWMOutput;
  PrepareFMOutput: TPrepareFMOutput;
  WriteNewPWMRatio: TWriteNewPWMRatio;
  WriteNewFMRatio: TWriteNewFMRatio;

  PrepareExtTrigger: TPrepareExtTrigger;
  StartMemoryMeasurement: TStartMemoryMeasurement;
  StartMemoryMeasurementEx: TStartMemoryMeasurementEx;
  StopMemoryMeasurement: TStopMemoryMeasurement;
  GetScaledDataFromMemoryMeasurement: TGetScaledDataFromMemoryMeasurement;
  GetBinaryDataFromMemoryMeasurement: TGetBinaryDataFromMemoryMeasurement;
  GetMemoryMeasurementStatus: TGetMemoryMeasurementStatus;
  DeInitMemoryMeasurement: TDeInitMemoryMeasurement;
  ShowDebugNumber: TShowDebugNumber;
  GetDLLVersion: TGetDLLVersion;

  ProgramUserTimerFrequency: TProgramUserTimerFrequency;
  StartUserTimer: TStartUserTimer;
  StopUserTimer: TStopUserTimer;
  SendICPSettings: TSendICPSettings;

  OutputPipe_PutScaledData: TOutputPipe_PutScaledData;
  OutputPipe_PutBinaryData: TOutputPipe_PutBinaryData;
  OutputPipe_GetFreeBufferSpace: TOutputPipe_GetFreeBufferSpace;

const
  cMaxChars = 1999;                                                             // PChar-Begrenzer fr DLL-Ladefunktion

var
  DllHandle: THandle;

function LoadFunctions(DLLPath: string; Var Errormessage: String): integer;stdcall;
function UnloadFunctions: integer;stdcall;
{$EndIf}

implementation

function ImportFunction(Name: string; var ErrorCount: integer; var ErrorString: string): Pointer;
var CharArray: array[0..cMaxChars] of char;
begin
  StrPCopy(@CharArray, Name);
  Result := Pointer(GetProcAddress(DllHandle,CharArray));
  if (Result=NIL) then
  begin
    inc(ErrorCount);
    ErrorString := ErrorString+Name+#13#10;
  end;
end;

function LoadFunctions(DLLPath: string; Var Errormessage: String): integer;
var CharArray: array[0..cMaxChars] of char;
    i: integer;
    s: string;
begin
  if (DLLPath>'') then
    if DLLPath[length(DLLPath)] <> '\' then                                     // Prfen, ob der Pfad mit \ terminiert wurde
      DLLPath := DLLPath+'\';                                                   // Ansonsten ergnzen
  StrPCopy(@CharArray, DLLPath+DllName);                                        // Pfad und Dateinamen zusammensetzen
  (* DLL laden *)
  DllHandle := LoadLibrary(CharArray);                                          // DLL laden
  If (DllHandle=0) then                                                         // DLL konnte nicht geladen werden
  begin
    Result := -1;                                                               // Fehler zurckmelden
    exit;                                                                       // und abbrechen
  end;
  (* Funktionen laden *)
  i := 0;s := '';                                                               // Zhler fr fehlgeschlagene Funktionen annulieren
  LoadCard:= TLoadCard(ImportFunction('LoadCard',i,s));                         // Und Funktionen importieren
  OpenCard:= TOpenCard(ImportFunction('OpenCard',i,s));
  SwitchCard:= TSwitchCard(ImportFunction('SwitchCard',i,s));
  CloseCard:= TCloseCard(ImportFunction('CloseCard',i,s));
  ReadFlashData:= TReadFlashData(ImportFunction('ReadFlashData',i,s));
  ReadflashDataEx:= TReadFlashDataEx(ImportFunction('ReadFlashDataEx',i,s));
  GetEnhancedInformations:= TGetEnhancedInformations(ImportFunction('GetEnhancedInformations',i,s));
  ConfigCard:= TConfigCard(ImportFunction('ConfigCard',i,s));

  ClearChannelLists:= TClearChannelLists(ImportFunction('ClearChannelLists',i,s));
  ClearChannelListsEx:= TClearChannelListsEx(ImportFunction('ClearChannelListsEx',i,s));
  FinalInit:= TFinalInit(ImportFunction('FinalInit',i,s));

  CaptureOneChannel:= TCaptureOneChannel(ImportFunction('CaptureOneChannel',i,s));
  CaptureOneChannelEx:= TCaptureOneChannelEx(ImportFunction('CaptureOneChannelEx',i,s));
  PrepareFilterEntry:= TPrepareFilterEntry(ImportFunction('PrepareFilterEntry',i,s));
  PrepareTriggerEntry:= TPrepareTriggerEntry(ImportFunction('PrepareTriggerEntry',i,s));
  SetGlobalTriggerValues:= TSetGlobalTriggerValues(ImportFunction('SetGlobalTriggerValues',i,s));
  PrepareTriggerTakt:= TPrepareTriggerTakt(ImportFunction('PrepareTriggerTakt',i,s));
  PrepareFFTEntry:= TPrepareFFTEntry(ImportFunction('PrepareFFTEntry',i,s));
  PreparePIDEntry:= TPreparePIDEntry(ImportFunction('PreparePIDEntry',i,s));

  GetFFTData:= TGetFFTData(ImportFunction('GetFFTData',i,s));
  Add_AD_Channel_To_ScanList:= TAdd_AD_Channel_to_ScanList(ImportFunction('Add_AD_Channel_to_ScanList',i,s));
  Add_Dig_Channel_To_Scanlist:= TAdd_Dig_Channel_to_ScanList(ImportFunction('Add_Dig_Channel_to_ScanList',i,s));
  Add_CT_Channel_to_ScanList:= TAdd_CT_Channel_to_ScanList(ImportFunction('Add_CT_Channel_to_ScanList',i,s));
  SetADFrequency:= TSetADFrequency(ImportFunction('SetADFrequency',i,s));
  SetADFrequencyEx:= TSetADFrequencyEx(ImportFunction('SetADFrequencyEx',i,s));
  StartADCapture:= TStartADCapture(ImportFunction('StartADCapture',i,s));
  StartADCaptureEx:= TStartADCaptureEx(ImportFunction('StartADCaptureEx',i,s));
  StopADCapture:= TStopADCapture(ImportFunction('StopADCapture',i,s));
  GetScaledData:= TGetScaledData(ImportFunction('GetScaledData',i,s));
  GetBinaryData:= TGetBinaryData(ImportFunction('GetBinaryData',i,s));

  PutOneChannel:= TPutOneChannel(ImportFunction('PutOneChannel',i,s));
  Add_DA_Channel_to_ScanList:= TAdd_DA_Channel_to_ScanList(ImportFunction('Add_DA_Channel_to_ScanList',i,s));
  Add_DA_Channel_to_ScanListEx:= TAdd_DA_Channel_to_ScanListEx(ImportFunction('Add_DA_Channel_to_ScanListEx',i,s));
  SetDAFrequency:= TSetDAFrequency(ImportFunction('SetDAFrequency',i,s));
  StartDAOutput:= TStartDAOutput(ImportFunction('StartDAOutput',i,s));
  StopDAOutput:= TStopDAOutput(ImportFunction('StopDAOutput',i,s));
  PutScaledData:= TPutScaledData(ImportFunction('PutScaledData',i,s));
  PutBinaryData:= TPutBinaryData(ImportFunction('PutBinaryData',i,s));
  GetDAFreeBufferSpace:= TGetDAFreeBufferSpace(ImportFunction('GetDAFreeBufferSpace',i,s));

  SetDigitalDirection:= TSetDigitalDirection(ImportFunction('SetDigitalDirection',i,s));
  ReadDigitalBit:= TReadDigitalBit(ImportFunction('ReadDigitalBit',i,s));
  WriteDigitalBit:= TWriteDigitalBit(ImportFunction('WriteDigitalBit',i,s));
  SetDigitalPortDirection:= TSetDigitalPortDirection(ImportFunction('SetDigitalPortDirection',i,s));
  ReadDigitalPort:= TReadDigitalPort(ImportFunction('ReadDigitalPort',i,s));
  WriteDigitalPort:= TWriteDigitalPort(ImportFunction('WriteDigitalPort',i,s));

  ConfigureCounterInput:= TConfigureCounterInput(ImportFunction('ConfigureCounterInput',i,s));
  ConfigureCounterInputEx:= TConfigureCounterInputEx(ImportFunction('ConfigureCounterInputEx',i,s));
  ReadCounterValue:= TReadCounterValue(ImportFunction('ReadCounterValue',i,s));
  CT_AddChannel_To_CTScanlist := TCT_AddChannel_To_CTScanlist(ImportFunction('CT_AddChannel_To_CTScanlist',i,s));
  SetCTFrequency := TSetCTFrequency(ImportFunction('SetCTFrequency',i,s));
  StartCTCapture := TStartCTCapture(ImportFunction('StartCTCapture',i,s));
  StartCTCaptureEx := TStartCTCaptureEx(ImportFunction('StartCTCaptureEx',i,s));
  StopCTCapture := TStopCTCapture(ImportFunction('StopCTCapture',i,s));
  CT_GetScaledData := TCT_GetScaledData(ImportFunction('CT_GetScaledData',i,s));
  CT_GetBinaryData := TCT_GetBinaryData(ImportFunction('CT_GetBinaryData',i,s));



  PreparePWMOutput:= TPreparePWMOutput(ImportFunction('PreparePWMOutput',i,s));
  PrepareFMOutput:= TPrepareFMOutput(ImportFunction('PrepareFMOutput',i,s));
  WriteNewPWMRatio:= TWriteNewPWMRatio(ImportFunction('WriteNewPWMRatio',i,s));
  WriteNewFMRatio:= TWriteNewFMRatio(ImportFunction('WriteNewFMRatio',i,s));

  PrepareExtTrigger:= TPrepareExtTrigger(ImportFunction('PrepareExtTrigger',i,s));
  StartMemoryMeasurement:= TStartMemoryMeasurement(ImportFunction('StartMemoryMeasurement',i,s));
  StartMemoryMeasurementEx:= TStartMemoryMeasurementEx(ImportFunction('StartMemoryMeasurementEx',i,s));
  StopMemoryMeasurement:= TStopMemoryMeasurement(ImportFunction('StopMemoryMeasurement',i,s));
  GetScaledDataFromMemoryMeasurement:= TGetScaledDataFromMemoryMeasurement(ImportFunction('GetScaledDataFromMemoryMeasurement',i,s));
  GetBinaryDataFromMemoryMeasurement:= TGetBinaryDataFromMemoryMeasurement(ImportFunction('GetBinaryDataFromMemoryMeasurement',i,s));
  GetMemoryMeasurementStatus:= TGetMemoryMeasurementStatus(ImportFunction('GetMemoryMeasurementStatus',i,s));
  DeInitMemoryMeasurement:= TDeInitMemoryMeasurement(ImportFunction('DeInitMemoryMeasurement',i,s));
  ShowDebugNumber:= TShowDebugNumber(ImportFunction('ShowDebugNumber',i,s));
  GetDLLVersion:= TGetDLLVersion(ImportFunction('GetDLLVersion',i,s));

  SendICPSettings:= TSendICPSettings(ImportFunction('SendICPSettings',i,s));

  OutputPipe_PutScaledData:= TOutputPipe_PutScaledData(ImportFunction('OutputPipe_PutScaledData',i,s));
  OutputPipe_PutBinaryData:= TOutputPipe_PutBinaryData(ImportFunction('OutputPipe_PutBinaryData',i,s));
  OutputPipe_GetFreeBufferSpace:= TOutputPipe_GetFreeBufferSpace(ImportFunction('OutputPipe_GetFreeBufferSpace',i,s));
  
  ErrorMessage := s;
  Result := i;
end;

function UnloadFunctions: integer;
begin
  if DllHandle=0 then
  begin
    Result := -1;
    exit;
  end;
  FreeLibrary(DllHandle);
  DllHandle := 0;
  Result := 0;
end;


end.
